//
// BitWise.c
//
// John Findlay
//
#include <stdio.h>
#include <limits.h>

/* macros operating on bits */
#define BITTST(i, n) (!!(i & (1 << n)))
#define BITCLR(i, n) (i &= ~(1 << n))
#define BITSET(i, n) (i |= (1 << n))
#define BITCHG(i, n) (i ^= (1 << n))

char* Bin(char* buff, unsigned long n, int size)
{
	size *= CHAR_BIT;

	for (int i = 0; i<size; i++){
		if (BITTST(n, i))
			buff[i] = '1';
		else
			buff[i] = '0';
 }

	buff[size]= 0; // null terminate the buffer.

	return buff;
}

int main(void)
{
	unsigned char c = 0xFF;
	char buf[33];
	int i;

	printf("Bit Clear %x\n", c);
	for (i = 0; i<8; i++){
		BITCLR(c, i);
		printf("%s ", Bin(buf, c, sizeof(c)));
		c = 0xFF;
	}
	printf("\n\n");

	c = 0x00;
	printf("Bit Set %x\n", c);
	for (i = 0; i<8; i++){
		BITSET(c, i);
		printf("%s ", Bin(buf, c, sizeof(c)));
		c = 0x00;
	}
	printf("\n\n");

	c = 0xAA;
	printf("Bit Test %x\n", c);
	for (i = 0; i<8; i++){
		printf("%s - Is bit %d set? %s\n", Bin(buf, c, sizeof(c)),
			(CHAR_BIT - i - 1), (BITTST(c, i) ? "yes" : "no"));
	}
	printf("\n\n");

	c = 0xFF;
	printf("Bit Change %x\n", c);
	for (i = 0; i<8; i++){
		BITCHG(c, i);
		printf("%s ", Bin(buf, c, sizeof(c)));
		c = 0xFF;
	}

	printf("\n\n");

	return 0;
}
